-- **************************************************************************
-- NAME : TitanPanelRightClickMenu_PreparePalsMenu()
-- DESC : <research>
-- **************************************************************************
function TitanPanelRightClickMenu_PreparePalsMenu()
	local info = {};
	local TitanUser = TitanGetVar(TITAN_PALS_ID, "TitanUser")
	if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then

		-- this is for whispering a friend
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_WHISPER ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = palsWisper;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- this is for removing a friend from friends list
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_REMOVE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = PalsRemove;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- This is for group Invites
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_INVITE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = PalsInvite;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- This is for setting friends note
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_NOTE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					--info.func = PalsNote;
					--info.value = Pals_name;
					info.hasArrow = 1;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end
		return;
	end
	if ( UIDROPDOWNMENU_MENU_LEVEL == 3 ) then
		local NumPals = GetNumFriends();
		local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
		local friendIndex
		for friendIndex=1, NumPals do
			Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);

			if ( UIDROPDOWNMENU_MENU_VALUE == TitanPalsList[TitanUser][Pals_name].name ) then
			--Debug line for Notes submenu
			TitanPals_Debug("Hit UIDropDownMenu_Value "..UIDROPDOWNMENU_MENU_VALUE.." / "..TitanPalsList[TitanUser][Pals_name].name)
				if ( Pals_connected ) then
					if ( Pals_class == "Warrior" ) then
						info = {};
						--Protection
						info.text = TITAN_PALS_NOTE_WPROT;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_WPROT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Arms
						info.text = TITAN_PALS_NOTE_WARMS;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_WARMS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Fury
						info.text = TITAN_PALS_NOTE_WFURY;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_WFURY;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Mage" ) then
						info = {};
						--Fire
						info.text = TITAN_PALS_NOTE_MFIRE;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_MFIRE;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Frost
						info.text = TITAN_PALS_NOTE_MFROS;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_MFROS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Arcane
						info.text = TITAN_PALS_NOTE_MARCA;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RSUBT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Paladin" ) then
						info = {};
						--Protection
						info.text = TITAN_PALS_NOTE_PPROT;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PPROT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Holy
						info.text = TITAN_PALS_NOTE_PHOLY;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PHOLY;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Retribution
						info.text = TITAN_PALS_NOTE_PRETR;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRETR;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Hunter" ) then
						info = {};
						--Beast Mastery
						info.text = TITAN_PALS_NOTE_HBEAS;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_HBEAS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Marksmanship
						info.text = TITAN_PALS_NOTE_HMARK;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_HMARK;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Survival
						info.text = TITAN_PALS_NOTE_HSURV;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_HSURV;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Rogue" ) then
						info = {};
						--Assassination
						info.text = TITAN_PALS_NOTE_RASSA;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RASSA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Combat
						info.text = TITAN_PALS_NOTE_RCOMB;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RCOMB;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Subtlety
						info.text = TITAN_PALS_NOTE_RSUBT;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RSUBT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Priest" ) then
						info = {};
						--Shadow
						info.text = TITAN_PALS_NOTE_PRSHA;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRSHA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Holy
						info.text = TITAN_PALS_NOTE_PRHOL;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRHOL;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Discipline
						info.text = TITAN_PALS_NOTE_PRDIS;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRDIS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Death Knight" ) then
						info = {};
						--Blood
						info.text = TITAN_PALS_NOTE_DKBLO;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DKBLO;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Frost
						info.text = TITAN_PALS_NOTE_DKFRO;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DKFRO;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--UnHoly
						info.text = TITAN_PALS_NOTE_DKUNH;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DKUNK;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Druid" ) then
						info = {};
						--Balance
						info.text = TITAN_PALS_NOTE_DBALA;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DBALA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Feral Combat
						info.text = TITAN_PALS_NOTE_DFERA;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DFERA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Restoration
						info.text = TITAN_PALS_NOTE_DREST;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DREST;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Shaman" ) then
						info = {};
						--Elemental
						info.text = TITAN_PALS_NOTE_SELEM;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_SELEM;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Enhancement
						info.text = TITAN_PALS_NOTE_SENHA;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_AENHA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Restoration
						info.text = TITAN_PALS_NOTE_SREST;
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_SREST;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
				end
			end
		end
		return;
	end
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_PALS_ID].menuText);

	-- create the title for the Whisper submenu
	info = {};
	info.text = TITAN_PALS_MENU_WHISPER;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	-- create the title for the Invite submenu
	info = {};
	info.text = TITAN_PALS_MENU_INVITE;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	-- create the title for the Ignore submenu
	info = {};
	info.text = TITAN_PALS_MENU_REMOVE;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	-- create the title for the Note submenu
	info = {};
	info.text = TITAN_PALS_MENU_NOTE;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	-- ShowOffLine Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWOFFLINE;
	info.func = TitanPals_ShowOffline;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowOffline");
	UIDropDownMenu_AddButton(info);

	-- ShowIgnored Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWIGNORED;
	info.func = TitanPals_ShowIgnored;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowIgnored");
	UIDropDownMenu_AddButton(info);

	-- ShowClass Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWCLASS;
	info.func = TitanPals_ShowClass;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowClass");
	UIDropDownMenu_AddButton(info);

	-- ShowNote Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWNOTE;
	info.func = TitanPals_ShowNote;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowNote");
	UIDropDownMenu_AddButton(info);

	-- NoAlts ToolTip Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_NOALTS;
	info.func = TitanPals_NoAltsToolTip;
	info.checked = TitanGetVar(TITAN_PALS_ID, "NoAlts");
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	-- MouseUpdate Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_MOUSEUPDATE;
	info.func = TitanPals_MouseUpdate;
	info.checked = TitanGetVar(TITAN_PALS_ID, "MouseUpdate");
	UIDropDownMenu_AddButton(info);

	if ( TitanUser == "Nagdand@Korialstrasz") then 
		info = {};
		info.text = TITAN_PALS_MENU_DEV;
		info.func = TitanPals_DevDebug;
		info.checked = TitanGetVar(TITAN_PALS_ID, "Debug");
		UIDropDownMenu_AddButton(info);
	
		TitanPanelRightClickMenu_AddSpacer();

	end

	TitanPanelRightClickMenu_AddToggleIcon(TITAN_PALS_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_PALS_ID);

	-- default Titan Panel right-click menu options
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_PALS_ID, TITAN_PANEL_MENU_FUNC_HIDE);

end